from PyQt4.QtCore import QSize
from PyQt4.QtGui import QColor, QFont

from lldbvis.util import Light, Material
from lldbvis.util.vectors import Vector4, Vector3

DEFAULT_MOUSE_SENSITIVITY = 0.005
DEFAULT_ZOOM_SPEED = 0.004
DEFAULT_MINIMAL_ZOOM = 30
DEFAULT_MAXIMAL_ZOOM = 0
MINIMAL_MOUSE_DRAG_INTENSITY = 0.01

DEFAULT_CAMERA_MOVEMENT_SPEED = 0.15
DEFAULT_CAMERA_POSITION = Vector3(0, 0, 10)
DEFAULT_CAMERA_EULER_ANGLES = Vector3()

DEFAULT_TEXT_COLOR = QColor(255, 255, 255)
ERROR_TEXT_COLOR = QColor(255, 0, 0)

COMMANDS_CATEGORY_H_SPACE = 25

LINE_NUMBER_AREA_PADDING_LEFT = 20
LINE_NUMBER_AREA_BACKGROUND_COLOR = QColor(200, 200, 200, 70)
LINE_NUMBER_AREA_FONT_COLOR = QColor(255, 255, 255, 120)

EDITOR_LINE_HIGHLIGHT_COLOR = QColor(255, 255, 255, 120).dark(255)

DEFAULT_WINDOW_SIZE = QSize(800, 600)

DEFAULT_OPENGL_TIMED_UPDATE_INTERVAL_MS = 30
OPENGL_BACKGROUND_COLOR = QColor(0.118 * 255.0, 0.133 * 255.0, 0.142 * 255.0, 255.0)

OPENGL_GLOBAL_LIGHT_AMBIENT = [0.4, 0.4, 0.4, 1.0]
OPENGL_LIGHT0 = Light(
    Vector4(0, 50, 100, 0),
    Vector4(0, 0, 0, 1),
    Vector4(1, 1, 1, 1),
    Vector4(1, 1, 1, 1))

OPENGL_FONT_COLOR = QColor(255, 255, 255)
OPENGL_FONT = QFont('Arial', 16)

OPENGL_LABEL_FONT_COLOR = QColor(255, 255, 255)
OPENGL_LABEL_FONT = QFont('Arial', 10)

OPENGL_PERSPECTIVE_NEAR = 0.1
OPENGL_PERSPECTIVE_FAR = 100.0
OPENGL_PERSPECTIVE_FOVY = 45.0

RUN_ARGUMENTS_DIALOG_SIZE = QSize(500, 0)

LAYOUT_MINIMAL_RADIUS = 2
LAYOUT_PUSH_FORCE = 0.3
LAYOUT_PUSH_DIRECT_CHILDREN_FACTOR = 4.0
LAYOUT_PUSH_CHILDREN_FACTOR = 0.2
LAYOUT_PUSH_PARENT_DIRECT_CHILDREN_FACTOR = 0.1
LAYOUT_DIAMETER_MULTIPLIER = 1.5

OPENGL_NODE_MATERIAL = Material(
    Vector4(0, 0, 0.025, 1),
    Vector4(0.4, 0.4, 0.45, 1),
    Vector4(0.04, 0.04, 0.37, 1),
    Vector4(0, 0, 0, 1),
    0.078125)

DEFAULT_OPENGL_NODE_RADIUS = 0.5

OPENGL_NODE_SPHERE_SLICES = 20
OPENGL_NODE_SPHERE_STACKS = 20

OPENGL_EDGE_CYLINDER_RADIUS = 0.03
OPENGL_EDGE_CYLINDER_SUBDIVISIONS = 5

OPENGL_MINIMAL_LABEL_ZOOM_DISTANCE = 35
